Attribute VB_Name = "Vectors"
' Copyright: Vladislav Petrovskiy (aka firehacker)
' For: http://bbs.vbstreets.ru/viewtopic.php?f=1&t=45726

Option Explicit

Public Type VECTOR2
    X   As Double
    Y   As Double
End Type


'
'    (va+vb)
'
Public Function V2Add(va As VECTOR2, vb As VECTOR2) As VECTOR2
    V2Add.X = va.X + vb.X
    V2Add.Y = va.Y + vb.Y
End Function

'
'    (va-vb)
'
Public Function V2Sub(va As VECTOR2, vb As VECTOR2) As VECTOR2
    V2Sub.X = va.X - vb.X
    V2Sub.Y = va.Y - vb.Y
End Function

'
'     ( )
'
Public Function V2Scale(v As VECTOR2, ByVal sf As Double) As VECTOR2
    V2Scale.X = v.X * sf
    V2Scale.Y = v.Y * sf
End Function

'
'    
'
Public Function V2Lerp(va As VECTOR2, vb As VECTOR2, ByVal sf As Double) As VECTOR2
    If sf < 0 Or sf > 1 Then Err.Raise 9
    V2Lerp.X = va.X * (1 - sf) + vb.X * sf
    V2Lerp.Y = va.Y * (1 - sf) + vb.Y * sf
End Function

'
'    ,  90
'
Public Function V2OrtoRot(v As VECTOR2, ByVal ortorot As Long) As VECTOR2
    ortorot = ortorot Mod 4
    If ortorot < 0 Then ortorot = ortorot + 4
    Select Case ortorot
        Case 1:     V2OrtoRot.X = -v.Y: V2OrtoRot.Y = v.X
        Case 2:     V2OrtoRot.X = -v.X: V2OrtoRot.Y = -v.Y
        Case 3:     V2OrtoRot.X = v.Y:  V2OrtoRot.Y = -v.X
    End Select
End Function

'
'        OX
'
Public Function V2GetOxAngle(v As VECTOR2) As Double
    If v.Y = 0 Then
        V2GetOxAngle = IIf(v.X > 0, 0, pi / 2)
    Else
        V2GetOxAngle = pi / 2 - Atn(v.X / v.Y) + IIf(v.Y < 0, pi, 0)
    End If
    If V2GetOxAngle < 0 Then V2GetOxAngle = 0
End Function

'
'   
'
Public Function V2GetLength(v As VECTOR2) As Double
    V2GetLength = Sqr(v.X ^ 2 + v.Y ^ 2)
End Function

'
'   (   )
'
Public Function V2Normalize(v As VECTOR2) As VECTOR2
    V2Normalize = V2Scale(v, 1 / V2GetLength(v))
End Function


